// CC-005 - Home Run Derpy
//
// This is coded fast, loose, and unsafe as hell.
// For the love of god, don't code a real game like this, okay?
//
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "raylib.h"


#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

#define SCREEN_W          1280
#define SCREEN_H           960
#define GLSL_VERSION       330

#define MAX_ACTORS         768
#define MAX_TEXTBOX          8
#define MAX_ANIMATIONS       4
#define MAX_FRAMES          16
#define MAX_SFX             32

#define PURE_GREEN       (Color){   0, 255,   0, 255 }
#define PURE_BLUE        (Color){   0,   0, 255, 255 }
#define PURE_YELLOW      (Color){ 255, 255,   0, 255 }
#define SCORE_PINK       (Color){ 242, 103, 119, 255 }
#define SCORE_ORANGE     (Color){ 255, 161,   0, 255 }
#define WATER            (Color){  25, 113, 180, 255 }
#define SCORE_GREEN      (Color){ 145, 240,   0, 255 }
#define SKY_BLUE         (Color){  25, 113, 180, 255 }

#define CUSTOMER_YELLOW  (Color){ 231, 230, 108, 255 }
#define CUSTOMER_GREEN   (Color){ 123, 232, 109, 255 }
#define CUSTOMER_PURPLE  (Color){ 190, 106, 229, 255 }
#define CUSTOMER_CYAN    (Color){ 107, 226, 230, 255 }


#define SESSION_TIME     10800
#define MOVE_SCALE        4.00
#define TILE_SIZE        16.00
#define ACTOR_SCALE       4.00

#define GRAVITY_PULL      0.10






// Update routines (should be called per-frame, or at fixed intervals)
// Project-specific routines are listed last
//
void check_textbox();
void check_animations();
void check_time();
void check_score();
void check_actors();
void check_input();
void check_sfx_buffer();
void check_customers();

void cleanup();
void end_game();
void show_stats();


// Spawning and actor maintenance routines
//
void kill_actor(int slot);
int  spawn_actor(int type, float x, float y, float z, int cell_x, float path_x, float path_y, float path_z);
int  spawn_baseball();
int  spawn_rack(int x, int y, int width, Texture2D tex);
int  spawn_bag(int x, int y, int z, int frame_x, int rack);
int  spawn_trail(int ball);
int  spawn_decal(int type, int ball);
int  spawn_customer();
void populate_rack(int rack, int y_offset);


void assign_animation(int who, int anim, int loops);
void kill_animation(int who);



// Drawing routines
//
void draw_actor(int slot);
void draw_summary();
void draw_tutorial();
void draw_high_score();
void draw_title_hud();
void draw_hud();
void draw_signal(int signal);



// Misc project-specific nonsense
//
void toss_stuff(int rack, int who, int col_x, int col_y, int col_z);
int pitch_baseball();
int analyze_swing(bool power, int up, int down, int ball);
int analyze_pitch(int ball);
void umpire_signal(int type);
void buffer_sfx(int sfx_slot, int ticks);


void draw_text_box(int slot);
void trigger_textbox(int slot, int x, int y, int w, int h, int message, int delay, int duration);
void trigger_open_event();
void trigger_close_event();

void update_and_render();
void render_frame(int mode);    // Standard rendering
void render_buffer(int mode);   // Render to framebuffer instead (for full-screen shaders)

void init_game_variables();

int  get_free_actor();
int  get_population(int team);
int  get_initial();

int  check_floats(float one, float two, float range);               // Checks if two floats are within [range]
int  check_move_collision(int who, float x, float y, float z);      // Checks if actor's coords impinge on stage boundaries






// Old Framework stuff here
int sorted[MAX_ACTORS][2];

void FR_merge_actors();
void FR_prep_for_sort();
void FR_quicksort(int low, int high);
void FR_swap_int(int n1, int n2, int index);
int  FR_2d_dist(int x1, int y1, int x2, int y2);
//float scale(float A, float A1, float A2, float Min, float Max);
float scale(float value, float source_min, float source_max, float scaled_min, float scaled_max);
// End nonsense


// Wrapping nonsense
void blit(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void blit_v(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void blit_h(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void push_rect(Rectangle *rect, float x, float y, float w, float h);



// Man, fucking clean all this random shit up before the next compo, okay?
//
char custom_text[80];


double rad_conv = (PI / 180);

int calculate     = 0;  // Defers calculations for so many frames
int tutorial_seen = 0;
int game_over     = 0;  // Triggers end of game (0 = game active. 1 = summary. 2 = high score)
int total_actors  = 0;  // Debugging var

int population[2] = { 0, 0 };

int select        = 0;  // Current player's menu selection
int accept        = 0;  // Current player's prompt selection
int yes_no        = 0;  // shows prompt when > 0

int score         = 0;  // Your score
int score_diff    = 0;  // Score differential. Positive values add, negative subtract.
int score_shake   = 0;  // Number of frames to "shake" score display. Used for negative hits.
int score_derps   = 0;  // Keeps track of consecutive misses
int launches      = 0;  // Items launched
int hits          = 0;  // Good hits
int misses        = 0;  // Misses
int cracks        = 0;  // Cracks landed on the back glass

int high_score    = 666;
unsigned char high_init[4] = { 71, 68, 82, 0 };

int slow_time     = 0;  // > 0 if time is slowed by player
int slow_frame    = 0;  // Current number of updates skipped by slowdown

int box_tex_x   = 0;    // For anchoring happy texture at game over summary
int box_tex_y   = 0;    //
int box_update  = 0;    //

int water_tex_x   = 0;  // For anchoring happy texture at game over summary
int water_tex_y   = 0;  //
int water_update  = 0;  //

int clock_min     = 0;  // Countdown readout
int clock_sec     = 0;  //
int clock_sub     = 0;  //

int quake_ticks    = 1800; // Frames before next quake
int quake_base     = 3600; // Base ticks
int quake_spread   = 1800; // Randomness to quakes
int quake_duration = 0;    // Quake frames left to animation

int game_ticks    = SESSION_TIME; // Number of clock ticks left in game (60 = 1 second)
int score_ticks   = 0;            // User for score tracking
int frame_ticks   = 0;            // Used for end game animations
int puppet        = -1;           // Actor being controlled by the player   (Batter)
int pitcher       = -1;           // Actor being controlled by the computer (Pitcher)
int pitch         = -1;           // Actor being pitched
int show_signal   = -1;           // Shows ball or strike indicator on screen
int swung         = 0;            // > 0 if current pitch has been swung at
int take_a_drink  = 0;            // Flag for needing a drink
int drunkosity    = 0;            // How drunk we are
int balls_left    = 20;           // Number of balls left. Game over when you run out
int swing_active  = 0;            // Are we swinging the bat?
int swing_angle   = 0;            // What angle did we commit to?
int sfx_buffer[16][2];            // Allows buffering of sounds (up to 16, by clock ticks)

int customer      = -1;
int doors[2]      = { -1, -1 };
int racks[8]      = { -1, -1, -1, -1, -1, -1, -1, -1 };
int counters[8]   = { -1, -1, -1, -1, -1, -1, -1, -1 };

int kill_off_step[4] = { -1, -1, -1, -1 };

int game_mode     = 0; // 0 = title.    1 = Tutorial.     2 = game.    3 = Game Over.     4 = Credits?
float anims[16]   = { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };
float t_angle[4]  = { 0.0, 0.0, 0.0, 0.0 };
float t_offset[4] = { 0.0, 90.0, 180.0, 270.0 };



int p_rate        = 60;  // Maximum ticks between ammo recharges
int p_max         = 10;  // Max ammo count
int p_light       = 0;   // Number of light shots player has fired
int p_heavy       = 0;   // Heavy shots fired
int p_l_hit       = 0;   // Light shots that landed on-target
int p_h_hit       = 0;   // Heavy shots

Camera2D camera      = { 0 };
Vector2 cam_velocity = { 0, 0 };

Vector2 mouse        = { 0, 0 };
Vector2 mouse_cam    = { 0, 0 };

Texture2D tex_ball;
Texture2D tex_strike;
Texture2D tex_back_wall;
Texture2D tex_back_decal;
Texture2D tex_background;
Texture2D tex_counter_3;
Texture2D tex_racks[8];
Texture2D tex_front_wall;
Texture2D tex_title;
Texture2D tex_emoji_1;
Texture2D tex_emoji_2;
Texture2D tex_emoji_3;
Texture2D tex_emoji_4;
Texture2D tex_16x;
Texture2D tex_32x;
Texture2D tex_doors;
Texture2D box_tex;

Sound sfx[MAX_SFX];

Font font1;         // Bubble font
Font font3;         // 3x5 font

RenderTexture2D target;       // For full-screen shader handling

Shader shader_chroma;         // Chromatic aberration shader
int loc_time     = 0;
int loc_strength = 0;
float seconds = 0.0f;
float strength = 0.0005f;



struct textbox_struct
{
 Rectangle pos;
 float scale;
 bool enabled;                // TRUE if this box is active
 int viewable_text;           // Number of chars currently exposed (starts at zero, counts up)
 int duration;                // Number of ticks before textbox closes. -1 if disabled
 int mode;                    // 0 = entering, 1 = displaying text, 2 = exiting
 int ticks;                   // Counts time between displaying characters
 const char *msg;
};

textbox_struct textbox[MAX_TEXTBOX];





struct anim_struct
{
 int frame_x[MAX_FRAMES];     // x cell of frame inside sprite sheet (cell, not pixel)
 int frame_y[MAX_FRAMES];     // y cell of frame inside sprite sheet
 int timing[MAX_FRAMES];      // timing in game "ticks" to get to next frame
 int total_frames;            // maximum number of frames in this sequence
};

anim_struct anim[MAX_ANIMATIONS];





struct actor_struct
{
 Texture2D cel;         // Pointer to source texture
 Vector3 pos;           // Position
 Vector3 offset;        // Destination (only used to move enemies around)
 Vector3 dest;          // Destination (only used to move enemies around)
 Vector3 path;          // Path of travel (x/y/z)
 Color color;           // Color tint (WHITE by default)

 float blend;           // Blend strength (0-1)    < only applies if not solid >
 float angle;           // Angle of rotation (0-360)
 float v_angle;         // Angle of movement (0-360)
 float scale;           // Actor scale (populated during projection)
 float roll;            // != 0 if actor rolls while in flight (typically +/- 0.5)
 float y_shift;         // Dirty hack to physically shift a sprite on y axis by ? pixels (pre-projection)

 float quake;           // > 0 if actor is rolling from damage
 float sinking;         // > 0 if actor is sinking into the sand
 float speed;           // Actor's base speed (0.0 to 0.20) which is added to their movement each turn

 int team;              // 1 = Rack    2 = Baseball    3 = Bags, etc
 int shadow;            // > -1 if an actor is their shadow
 int _size_w;           // Dimensions of the cel frame
 int _size_h;           // Dimensions of the cel frame
 int flip;              // Force horizontal mirroring
 int anim_set;          // Animation set to reference
 int anim_step;         // Which step in the anim sequence we're at
 int anim_timing;       // Current step timing for animation
 int anim_loop;         // # of times to loop animation. 0 if only played once
 int mode;              // 0 = solid. 1 = alpha
 int state;             // 0 = inactive. 1-12 = doing stuff
 int effect;            // 0 = none.
 int home;              // Rack that owns this object
 int timer;             // Internal timer for animation purposes, or whatever you need
 int stamina;           // Walking and being attacked drain stamina. When <= 0 the actor dies or fades out
 int cel_x;             // X cel within sprite sheet
 int cel_y;             // Y cel within sprite sheet
 int locked_to;         // Actor this player was triggered by (so ammo doesn't hit the actor firing it!)
 int committed;         // > 0 if actor is committed to an activity
 int event;             // > 0 if actor will trigger an event when their commitment has ended
 int good_pitch;        // Lazy way of identifying a ball that passed through the strike zone

 float scale_ramp;      // Maximum value scale additive will ramp to
 float scale_mod;       // Modifies scale variable, when rendering sprite. This is a factor.
 float scale_up;        // Speed of scale ramping
 float scale_down;      // Speed of scale ramping

 int updates;           // Number of movement updates per -tick (default is 1)
 int moved_up;          // > 0 if actor has moved up recently
 int moved_down;        // > 0 if actor has moved down recently
 int moved_wait;        // > 0 if actor needs to wait before heading to next way-point

 int d_pad[4];          // Janky virtual gamepad (refine later)
 int buttons[4];        //

 int shader;            // > 0 if a shader is in use with this actor
 float s_vars[10];      // Storage space for shader vars. These will vary according to the shader in use

 bool decal;            // Indicates actor is a floor decal, and will be drawn before normal actors
 bool flicker;          // Tracks actor flicker (used by effects)
 bool mirror;           // TRUE if actor is mirrored on X-axis
 bool gravity;          // TRUE if gravity affects Y coordinate
 bool projected;        // TRUE is actor is passed through projection stage before drawing
 bool enabled;          // TRUE if this actor is active
 bool accessory;        // TRUE if actor will be rendered with a package object
                        // and should not be drawn or interacted with otherwise
};

actor_struct actors[MAX_ACTORS];





// I got tired of making everything global. Fuck me.
//
struct hi_struct
{
 int selected;                // Character currently selected (0-2 valid)
 unsigned char initials[3];   // Stores characters entered by user
 int blink;                   // True if we can display blinking chars
 int blink_timer;             // Timer to track above variable
};

hi_struct hi_score;




bool SKIP_INTRO = 0;          // TRUE if we want to skip the title screen and tutorial
float debug[10] = { 0.0, 0.0, 0.0, 0.0, 0.0,   0.0, 0.0, 0.0, 0.0, 0.0 };





const char *state_string[] = {
 /* 00 */ "SOBER",
 /* 01 */ "OKAY",
 /* 02 */ "MELLOW",
 /* 03 */ "BUZZING",
 /* 04 */ "TOASTY",
 /* 05 */ "WONKY",
 /* 06 */ "PISSED",
 /* 07 */ "BLOTTO",
 /* 08 */ "PICKLED",
 /* 09 */ "FUBAR",
 /* 10 */ "BLARGH",
 /* 11 */ "",
 /* 12 */ "",
 /* 13 */ "",
 /* 14 */ "",
 /* 15 */ "",
 /* 16 */ "",
 /* 17 */ "",
 /* 18 */ ""
};






int main(void)
{
 int i    = 0;
 int k    = 0;
 int next = 0;
 int exit = 0;
 char rep_str[37];



    // Init OpenGL, etc
    //
    //SetConfigFlags(FLAG_WINDOW_UNDECORATED);
    InitWindow(SCREEN_W, SCREEN_H, "CC-005 - Home Run Derpy");
    InitAudioDevice();

    SetTargetFPS(60);
    HideCursor();


    // Load shader and setup location points and values
    //
    shader_chroma = LoadShader(0, "shader/chroma.fs");
    loc_time     = GetShaderLocation(shader_chroma, "seconds");
    loc_strength = GetShaderLocation(shader_chroma, "strength");

    float screenSize[2] = { (float)GetScreenWidth(), (float)GetScreenHeight() };

    target = LoadRenderTexture(SCREEN_W, SCREEN_H);

    // Load textures
    //
    tex_ball         = LoadTexture("gfx/tex_ball.png");
    tex_strike       = LoadTexture("gfx/tex_strike.png");
    tex_title        = LoadTexture("gfx/tex_title.png");
    tex_emoji_1      = LoadTexture("gfx/tex_emoji_1.png");
    tex_emoji_2      = LoadTexture("gfx/tex_emoji_2.png");
    tex_emoji_3      = LoadTexture("gfx/tex_emoji_3.png");
    tex_emoji_4      = LoadTexture("gfx/tex_emoji_4.png");
    tex_counter_3    = LoadTexture("gfx/tex_counter_3.png");
    tex_back_wall    = LoadTexture("gfx/tex_back_wall.png");
    tex_back_decal   = LoadTexture("gfx/tex_back_decal.png");
    tex_background   = LoadTexture("gfx/tex_background.png");
    tex_front_wall   = LoadTexture("gfx/tex_front_wall.png");
    tex_16x          = LoadTexture("gfx/tex_16x.png");
    tex_32x          = LoadTexture("gfx/tex_32x.png");
    tex_doors        = LoadTexture("gfx/tex_doors.png");
    box_tex          = LoadTexture("gfx/box_tex.png");

    tex_racks[0]     = LoadTexture("gfx/tex_rack_1.png");
    tex_racks[1]     = LoadTexture("gfx/tex_rack_2.png");
    tex_racks[2]     = LoadTexture("gfx/tex_rack_3.png");
    tex_racks[3]     = LoadTexture("gfx/tex_rack_4.png");
    tex_racks[4]     = LoadTexture("gfx/tex_rack_5.png");
    tex_racks[5]     = LoadTexture("gfx/tex_rack_6.png");
    tex_racks[6]     = LoadTexture("gfx/tex_rack_7.png");
    tex_racks[7]     = LoadTexture("gfx/tex_rack_8.png");

    // Custom font loading
    //
    font1 = LoadFont("gfx/16x_bubble.png");
    font3 = LoadFont("gfx/3x_square.png");


    // Load sound effects
    //
    sfx[2]  = LoadSound("sfx/002.wav"); // OK GUI beep
    sfx[3]  = LoadSound("sfx/003.wav"); // Wrong/NOPE GUI beep
    sfx[4]  = LoadSound("sfx/004.wav"); // Bat strike #1
    sfx[5]  = LoadSound("sfx/005.wav"); // Bat strike #2
    sfx[6]  = LoadSound("sfx/006.wav"); // Bat Strike #3
    sfx[7]  = LoadSound("sfx/007.wav"); // Bat strike #4
    sfx[8]  = LoadSound("sfx/008.wav"); // Rack strike
    sfx[9]  = LoadSound("sfx/009.wav"); // Glass crack #1
    sfx[10] = LoadSound("sfx/010.wav"); // Glass crack #2
    sfx[11] = LoadSound("sfx/011.wav"); // Drinking stuff

    sfx[20] = LoadSound("sfx/020.wav"); // Boxes tumbling 1
    sfx[21] = LoadSound("sfx/021.wav"); // Boxes tumbling 2
    sfx[22] = LoadSound("sfx/022.wav"); // Boxes tumbling 3
    sfx[23] = LoadSound("sfx/023.wav"); // Boxes tumbling 4
    sfx[24] = LoadSound("sfx/024.wav"); // Door "ding"
    sfx[25] = LoadSound("sfx/025.wav"); // Door sliding


    // Set sound effect attributes
    //
    SetSoundVolume(sfx[2], 0.25);
    SetSoundPitch(sfx[2],  1.00);

    SetSoundVolume(sfx[3], 0.25);
    SetSoundPitch(sfx[3],  1.00);

    SetSoundVolume(sfx[4], 0.50);
    SetSoundPitch(sfx[4],  1.00);

    SetSoundVolume(sfx[5], 0.50);
    SetSoundPitch(sfx[5],  1.00);

    SetSoundVolume(sfx[6], 0.50);
    SetSoundPitch(sfx[6],  1.00);

    SetSoundVolume(sfx[7], 0.50);
    SetSoundPitch(sfx[7],  1.00);

    SetSoundVolume(sfx[8], 0.50);
    SetSoundPitch(sfx[8],  1.00);

    SetSoundVolume(sfx[9], 0.15);
    SetSoundPitch(sfx[9],  1.00);

    SetSoundVolume(sfx[10], 0.15);
    SetSoundPitch(sfx[10],  1.00);

    SetSoundVolume(sfx[11], 0.50);
    SetSoundPitch(sfx[11],  0.90);

    SetSoundVolume(sfx[24], 0.50);
    SetSoundPitch(sfx[24],  1.00);

    SetSoundVolume(sfx[25], 0.50);
    SetSoundPitch(sfx[25],  1.00);


    // We will call this routine to clean up on program exit
    //
    atexit(cleanup);


    // We will land here after a successful game loop
    //
    restart:


    init_game_variables();


    // Create racks. These exist as actors, so they will sort and mask properly
    //
    racks[0] = spawn_rack( 43,  71 + 24,  82, tex_racks[0]); populate_rack(0, 0); populate_rack(0, -2);
    racks[1] = spawn_rack(149,  71 + 24,  69, tex_racks[1]); populate_rack(1, 0); populate_rack(1, -2);
    racks[2] = spawn_rack( 43,  99 + 24, 175, tex_racks[2]); populate_rack(2, 0); populate_rack(2, -2);
    racks[3] = spawn_rack( 43, 136 + 24,  64, tex_racks[3]); populate_rack(3, 0); populate_rack(3, -2);
    racks[4] = spawn_rack(132, 136 + 24,  86, tex_racks[4]); populate_rack(4, 0); populate_rack(4, -2);
    racks[5] = spawn_rack( 43, 164 + 24,  89, tex_racks[5]); populate_rack(5, 0); populate_rack(5, -2);
    racks[6] = spawn_rack(156, 164 + 24,  62, tex_racks[6]); populate_rack(6, 0); populate_rack(6, -2);
    racks[7] = spawn_rack( 43, 192 + 24, 175, tex_racks[7]); populate_rack(7, 0); populate_rack(7, -2);


    // Create Fan blades in the chillers (11x)
    //
    for(i=0; i<11; i++) {
        k = spawn_actor(0, 44.0 + (80.00 * i), 320.0, 164.0,  20,  0.0, 0.0, 0.0);
        if(k != -1) {
            actors[k].angle = GetRandomValue(0, 360);
            actors[k].roll  = 5.00;
            actors[k].scale = 4.00;
            actors[k].state = 8;
            actors[k].blend = 0.10;
                    }
                        }

    // Sliding glass doors (2x)
    //
    for(i=0; i<2; i++) {
        doors[i] = spawn_actor(0, 249*4, 239*4, 0.0,  i,  0.0, 0.0, 0.0);
        if(doors[i] != -1) {
            actors[doors[i]].stamina = 0;
            actors[doors[i]].scale   = 4.00;
            actors[doors[i]].state   = 9;
            actors[doors[i]].pos.x   += (17 * 4 * i);
            actors[doors[i]].cel     = tex_doors;
            actors[doors[i]]._size_w = 32;
            actors[doors[i]]._size_h = 64;
                           }
                        }

    // We need to handle the counter facing the front door, so it masks properly
    //
    counters[0] = spawn_rack(313, 182, 0, tex_counter_3);
    if(counters[0] != -1) { actors[counters[0]].effect = 0; }



    if(SKIP_INTRO) { goto skip_jank; }


    /// Title block loop ---------------------------------------------------------------------------------------
    //
    do {
        anims[0] = 1.00;
        update_and_render();

///        anims[15] += 0.05;
///        if(anims[15] >= 360.00) { anims[15] -= 360.00; }

        if(IsKeyDown(KEY_Z)) { next = 1; }
        if(next && (!IsKeyDown(KEY_Z))) { PlaySound(sfx[2]); exit = 1; }

       } while (!exit);



    // Fade Title out
    //
    do {
        anims[0] -= 0.025;
        update_and_render();
       } while (anims[0] > 0.00);



    /// Tutorial Loop ------------------------------------------------------------------------------------------
    //
    if(!tutorial_seen) {
        // Tutorial Display loop (only on first game of each session)
        //
        next      = 0;
        exit      = 0;
        game_mode = 1;

        do {
            update_and_render();

            if(IsKeyDown(KEY_Z)) { next = 1; }
            if(next && (!IsKeyDown(KEY_Z))) { PlaySound(sfx[2]); exit = 1; }

           } while (!exit);


        // Fade Title out
        //
        do {
            anims[1] -= 0.04;
            update_and_render();
           } while (anims[1] > 0.00);

        tutorial_seen = 1;
                       }



    skip_jank:

    /// Main Game Loop -----------------------------------------------------------------------------------------
    //
    next      = 0;
    exit      = 0;
    game_mode = 2;


    // Create batter actor
    //
    puppet = spawn_actor(0, 112, 568, 0, 0, 0.0, 0.0, 0.0);
    actors[puppet].scale   = 4.0;
    actors[puppet].cel     = tex_32x;
    actors[puppet]._size_w = 32;
    actors[puppet]._size_h = 32;

    // ...and shadow
    //
    k = spawn_actor(0, 112, 567, -6, 19, 0.0, 0.0, 0.0);
    actors[k].scale   = 4.0;
    actors[k].cel     = tex_32x;
    actors[k]._size_w = 32;
    actors[k]._size_h = 32;
    actors[puppet].shadow = k;



    // Create pitcher actor
    //
    pitcher = spawn_actor(0, 1085, 568, 0, 6, 0.0, 0.0, 0.0);
    actors[pitcher].scale   = 4.0;
    actors[pitcher].state   = 5;
    actors[pitcher].event   = 0;
    actors[pitcher].cel     = tex_32x;
    actors[pitcher]._size_w = 32;
    actors[pitcher]._size_h = 32;

    // ...and shadow
    //
    k = spawn_actor(0, 1085, 567, -6, 19, 0.0, 0.0, 0.0);
    actors[k].scale   = 4.0;
    actors[k].cel     = tex_32x;
    actors[k]._size_w = 32;
    actors[k]._size_h = 32;
    actors[pitcher].shadow = k;



    while (!game_over) {

        if(take_a_drink) {
            take_a_drink = 0;
            if(drunkosity < 10) { drunkosity++; }
                         }

        if(balls_left == 0 && pitch == -1) { game_over = 1; }

        // Update drunk shader
        //
        seconds += GetFrameTime();
        strength = 0.00035 + (drunkosity * 0.0001);

        SetShaderValue(shader_chroma, loc_time,     &seconds,  UNIFORM_FLOAT);
        SetShaderValue(shader_chroma, loc_strength, &strength, UNIFORM_FLOAT);

/*
        if(IsKeyDown(KEY_Q)) {
            do { update_and_render(); } while(IsKeyDown(KEY_Q));
            customer = spawn_customer();
                             }

        if(IsKeyDown(KEY_E)) {
            actors[doors[0]].stamina = 122;
            actors[doors[0]].path.x  = -0.50;

            actors[doors[1]].stamina = 122;
            actors[doors[1]].path.x  = 0.50;
            buffer_sfx(25, 0);
            buffer_sfx(24, 120);
                             }

        if(IsKeyDown(KEY_R)) {
            actors[doors[0]].stamina = 122;
            actors[doors[0]].path.x  = 0.50;

            actors[doors[1]].stamina = 122;
            actors[doors[1]].path.x  = -0.50;
            buffer_sfx(25, 0);
                             }

        if(IsKeyDown(KEY_G)) { balls_left = 0; }

        if(IsKeyDown(KEY_SPACE)) {
            pitch = pitch_baseball();
            balls_left--;
            do { update_and_render(); } while(IsKeyDown(KEY_SPACE));
                                 }
*/

        update_and_render();


    if(drunkosity && game_mode == 2) {
        camera.rotation = (sin(anims[15] * rad_conv) * (2.00 * (drunkosity / 10.00)));
        camera.zoom     = 1.0 + (sin(anims[2] * rad_conv) * (0.015 * (drunkosity / 10.00)));
                                     }
    else {
        camera.rotation = 0.00;
        camera.zoom     = 1.00;
         }

                       }


    // End game summary and high score
    //
    end_game();

    goto restart;

    return(0);
}





// This routine is automatically called at program exit
//
void cleanup()
{
 int i = 0;

 // Free resources and clean up
 //
 UnloadTexture(tex_ball);
 UnloadTexture(tex_strike);
 UnloadTexture(tex_title);
 UnloadTexture(tex_emoji_1);
 UnloadTexture(tex_emoji_2);
 UnloadTexture(tex_emoji_3);
 UnloadTexture(tex_emoji_4);
 UnloadTexture(tex_counter_3);
 UnloadTexture(tex_back_decal);
 UnloadTexture(tex_background);
 UnloadTexture(tex_back_wall);
 UnloadTexture(tex_front_wall);
 UnloadTexture(tex_16x);
 UnloadTexture(tex_32x);
 UnloadTexture(tex_doors);
 UnloadTexture(box_tex);

 for(i=0; i<8; i++) { UnloadTexture(tex_racks[i]); }

 UnloadFont(font1);
 UnloadFont(font3);

 UnloadSound(sfx[2]);
 UnloadSound(sfx[3]);
 UnloadSound(sfx[5]);
 UnloadSound(sfx[6]);
 UnloadSound(sfx[7]);

 CloseWindow();                // Close window and OpenGL context

 return;
}






// Performs logic update and calls rendering stuff
//
void update_and_render()
{
 int moved      = 0;
 int stride     = 0;
 int i          = 0;
 float rotation = 0.0;
 float offset   = 0.0;

 total_actors   = 0;


 if(WindowShouldClose()) { exit(0); }


 check_animations();
 check_textbox();
 check_actors();


 if(!game_over && game_mode > 1) {
     check_sfx_buffer();
     check_customers();
     check_input();
     check_score();

     if(!slow_time || (slow_time && slow_frame > 3)) {
         check_time();
         slow_frame = 0;
                                                     }
     else { slow_frame++; }
                                 }

 if(!drunkosity || game_mode != 2) { render_frame(game_mode);  }
 else                              { render_buffer(game_mode); }

 return;
}







void render_frame(int mode)
{
 int i   = 0;
 int j   = 0;
 int k   = 0;
 int t_x = 0;
 int t_y = 0;

 float quake_scale = 0.0;
 float mouse_scale = 1.0;
 float offset      = 0.0;
 float angle       = 0.0;
 float y_scale     = 0.5;
 float scale       = 1.0;
 float x_shift     = 0.0;



 if(quake_duration) {
     quake_scale = 30.0 * ((float)quake_duration / 180.00);
     camera.offset.x += GetRandomValue(-quake_scale, quake_scale);
     camera.offset.y += GetRandomValue(-quake_scale, quake_scale);
     quake_duration--;
                    }
 else {
     camera.offset.x = (float)SCREEN_W / 2.0f;
     camera.offset.y = (float)SCREEN_H / 2.0f;
      }


 BeginDrawing();
 BeginMode2D(camera);


 DrawTextureEx(tex_background, (Vector2){0, 0}, 0.0, 4.0, WHITE);


 // Sort actors
 //
 FR_prep_for_sort();
 FR_quicksort(0,(MAX_ACTORS-1));
 FR_merge_actors();

 DrawTextureEx(tex_front_wall, (Vector2){0,800}, 0.0, 4.0, WHITE);


 // Having drawn all the necessary stuff, handle mode-specific overlays
 //
 switch(game_mode) {
     case 0: // Title screen
             draw_title_hud();
             break;

     case 1: // Introduction / Tutorial
             draw_tutorial();
             break;

     case 2: // In-game
             if(show_signal != -1) { draw_signal(show_signal); }
             break;

     case 3: // Game over / Summary
             draw_summary();
             break;
                   }


 if(!game_over && game_mode > 1) { draw_hud(); }

 EndMode2D();
 EndDrawing();

 return;
}





void render_buffer(int mode)
{
 int i   = 0;
 int j   = 0;
 int k   = 0;
 int t_x = 0;
 int t_y = 0;

 float quake_scale = 0.0;
 float mouse_scale = 1.0;
 float offset      = 0.0;
 float angle       = 0.0;
 float y_scale     = 0.5;
 float scale       = 1.0;
 float x_shift     = 0.0;



 if(quake_duration) {
     quake_scale = 30.0 * ((float)quake_duration / 180.00);
     camera.offset.x += GetRandomValue(-quake_scale, quake_scale);
     camera.offset.y += GetRandomValue(-quake_scale, quake_scale);
     quake_duration--;
                    }
 else {
     camera.offset.x = (float)SCREEN_W / 2.0f;
     camera.offset.y = (float)SCREEN_H / 2.0f;
      }


 BeginTextureMode(target);
 BeginMode2D(camera);


 //if(drunkosity) { BeginShaderMode(shader_chroma); }

 DrawTextureEx(tex_background, (Vector2){0, 0}, 0.0, 4.0, WHITE);


 // Sort actors
 //
 FR_prep_for_sort();
 FR_quicksort(0,(MAX_ACTORS-1));
 FR_merge_actors();

 DrawTextureEx(tex_front_wall, (Vector2){0,800}, 0.0, 4.0, WHITE);


 // Having drawn all the necessary stuff, handle mode-specific overlays
 //
 switch(game_mode) {
     case 0: // Title screen
             draw_title_hud();
             break;

     case 1: // Introduction / Tutorial
             draw_tutorial();
             break;

     case 2: // In-game
             if(show_signal != -1) { draw_signal(show_signal); }
             break;

     case 3: // Game over / Summary
             draw_summary();
             break;
                   }


 if(!game_over && game_mode > 1) { draw_hud(); }


 EndMode2D();
 EndTextureMode();


 BeginDrawing();
 BeginShaderMode(shader_chroma);
 DrawTextureRec(target.texture, (Rectangle){ 0, 0, (float)target.texture.width, (float)-target.texture.height }, (Vector2){ 0, 0 }, WHITE);
 EndShaderMode();
 EndDrawing();


 return;
}





// NOTE: Typical usage is to put the box over a character or tile's position
//
void draw_text_box(int slot)
{
 Rectangle dest;
 char strang[80];

 Vector2 text_coords;
 Vector2 text_len;


 if(!textbox[slot].enabled) { return; }
 if(textbox[slot].mode < 0) { return; }


 // Calculate textbox dimensions, etc
 //
 dest.width  = textbox[slot].pos.width  * textbox[slot].scale;
 dest.height = textbox[slot].pos.height * textbox[slot].scale;

 dest.x = textbox[slot].pos.x - (dest.width / 2.0f);
 dest.y = textbox[slot].pos.y - (dest.height / 2.0f);


 // Draw border around box
 //
 DrawRectangleLinesEx(dest, 4, WHITE);


 // Draw tiled texture (happy face) and update anchor coordinates
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 64, 32 };
 Rectangle tex_d = { dest.x+3, dest.y+3, dest.width - 6, dest.height - 6 };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 // Measure text and box and figure out how to center text
 //
 text_len = MeasureTextEx(font3, textbox[slot].msg, (font3.baseSize * 2), 1);

 text_coords.x = dest.x + (dest.width / 2) - (text_len.x / 2);
 text_coords.y = dest.y + (dest.height / 2.0f) - font3.baseSize;


 // Draw characters
 //
 if(textbox[slot].viewable_text > 0) {
     memset(strang, 0, sizeof(strang));
     strncpy(strang, textbox[slot].msg, textbox[slot].viewable_text);
     DrawTextEx(font3, strang, text_coords, (font3.baseSize * 2), 1, WHITE);
                                     }

 return;
}





void draw_high_score()
{

 return;
}




// NOTE: Checks player input for activity
//
void check_input()
{
 int k = 0;
 bool can_swing = 0;


 // First stop, evaluate whether or not the player can take a swing
 // Pitch has to be active, (which implies it's in motion), and not past the strike zone
 //
 if(pitch != -1 && !swung) { can_swing = 1; }

 if(swing_active > 0) { swing_active--; }


    if(can_swing && !swing_active && pitch != -1) {
        if(IsKeyDown(KEY_X)) {
            swung = 1;
            swing_active = 120;
            k = analyze_swing(1, IsKeyDown(KEY_UP), IsKeyDown(KEY_DOWN), pitch);
            if(k) { quake_duration = 20; }

            if(IsKeyDown(KEY_UP))   { swing_angle = 1; }
            if(IsKeyDown(KEY_DOWN)) { swing_angle = 2; }
                             }

        if(IsKeyDown(KEY_Z)) {
            swung = 1;
            swing_active = 120;
            analyze_swing(0, IsKeyDown(KEY_UP), IsKeyDown(KEY_DOWN), pitch);
            if(k) { quake_duration = 20; }

            if(IsKeyDown(KEY_UP))   { swing_angle = 1; }
            if(IsKeyDown(KEY_DOWN)) { swing_angle = 2; }
                             }

                                                  }

 // Set Player's animation frame based off of swing state + angle (or drinking)
 //
 if(swing_active) {
     actors[puppet].cel_x = 3;
     if(swing_angle == 1) { actors[puppet].cel_x = 4; }
     if(swing_angle == 2) { actors[puppet].cel_x = 5; }
                  }

 else {
     if(IsKeyDown(KEY_UP) || IsKeyDown(KEY_DOWN)) {
         if(IsKeyDown(KEY_UP))   { actors[puppet].cel_x = 1; }
         if(IsKeyDown(KEY_DOWN)) { actors[puppet].cel_x = 2; }
                                                     }
     else { actors[puppet].cel_x = 0; }
      }


 // Override this if we're drinking (so lazy!)
 //
 if(actors[puppet].state == 7) { actors[puppet].cel_x = 9; }


 return;
}




void check_sfx_buffer()
{
 int i = 0;


 for(i=0; i<16; i++) {
     if(sfx_buffer[i][0] != -1) {
         sfx_buffer[i][1]--;

         if(sfx_buffer[i][1] <= 0) {
             PlaySound(sfx[sfx_buffer[i][0]]);
             sfx_buffer[i][0] = -1;
             sfx_buffer[i][1] = 0;
                                   }

                                }
                     }

 return;
}




void check_textbox()
{
 int i = 0;
 int len = 0;

 for(i=0; i<MAX_TEXTBOX; i++) {
     if(textbox[i].enabled) {
         switch(textbox[i].mode) {
                     break;

             case 0: // Entering
                     textbox[i].scale += 0.075;
                     if(textbox[i].scale >= 1.00) { textbox[i].scale = 1.00; textbox[i].mode++; }
                     break;

             case 1: // Displaying text
                     len = strlen(textbox[i].msg);
                     if(textbox[i].viewable_text < len) {
                         textbox[i].ticks++;
                         if(textbox[i].ticks > 3) { textbox[i].viewable_text++; PlaySound(sfx[5]); textbox[i].ticks = 0; }
                                                        }
                     else { textbox[i].ticks++; } // Keep counting ticks, in case useful

                     if(textbox[i].duration != -1) {
                         if(textbox[i].ticks > textbox[i].duration) { textbox[i].mode = 2; }
                                                   }
                     break;

             case 2: // Exiting
                     textbox[i].viewable_text = 0;
                     textbox[i].scale -= 0.075;
                     if(textbox[i].scale <= 0.00) { textbox[i].scale = 0.00; textbox[i].enabled = 0; }
                     break;
                                 }

         if(textbox[i].mode < 0) { textbox[i].mode++; } // Pause before beginning, effectively

                            }
                              }

 // Update background texture position
 //
 if(!box_update) {
     box_tex_x--;
     box_tex_x &= 0x3F;

     box_tex_y++;
     box_tex_y &= 0x1F;

     box_update = 1;
                   }

 else { box_update = 0; }


 // Update water texture position
 //
 if(water_update > 60) {
     water_tex_x++;
     water_tex_x &= 0xFF;

     water_tex_y = 0;
     water_update = 0;
                   }

 else { water_update++; }

 return;
}






// Adjusts score over time
//
void check_score()
{
 int factor = 1;
 int total  = 0;
 int i      = 0;


 // Score shakes when bad things happen
 //
 if(score_shake > 0) { score_shake--; }


 // Roll differential into score over time. The larger the difference,
 // the faster we will update the score.
 //
 if(score_diff != 0) {

     total = abs(score_diff);
     if(total > 20)   { factor = 1;  }
     if(total > 50)   { factor = 2;  }
     if(total > 100)  { factor = 4;  }
     if(total > 250)  { factor = 12; }
     if(total > 500)  { factor = 16; }
     if(total > 999)  { factor = 24; }
     if(total > 1999) { factor = 32; }
     if(total > 3999) { factor = 48; }
     if(total > 6999) { factor = 64; }

     if(score_diff > 0) { score += factor; score_diff -= factor; }
     if(score_diff < 0) { score -= factor; score_diff += factor; }
                     }

 // Bounds check
 //
 if(score < 0)        { score = 0;        }
 if(score > 99999999) { score = 99999999; }



 return;
}






void check_animations()
{
 int i = 0;
 int SET = 0;

 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled && actors[i].anim_set) {
         SET = actors[i].anim_set;

         actors[i].anim_timing++;

         /// printf("%d,",actors[i].anim_timing);

         // Check for frame advance
         //
         if(actors[i].anim_timing >= anim[SET].timing[actors[i].anim_step]) {
             actors[i].anim_step++;
             actors[i].anim_timing = 0;

             // Check for end, or looping
             //
             if(actors[i].anim_step >= anim[SET].total_frames) {
                 if(actors[i].anim_loop) {
                     actors[i].anim_step = 0;
                     actors[i].anim_timing = 0;
                     actors[i].anim_loop--;
                                         }

                 else { actors[i].anim_set = 0; }
                                                               }
                                                                            }

         // If anim is still set, update frame
         // ** SHOULD PLACE IN ROUTINE SO WE CAN SANITY CHECK ANIM_STEP VALUE **
         //
         if(actors[i].anim_set) {
             SET = actors[i].anim_set;
             actors[i].cel_x = anim[SET].frame_x[actors[i].anim_step];
             actors[i].cel_y = anim[SET].frame_y[actors[i].anim_step];
                                }
                                                 }
                             }


 // Floating object animation
 //
 anims[2] += 1.0;
 if(anims[2] > 360.00) { anims[2] -= 360.00; }


 // Flashing mini-map indicator animation
 //
 anims[3] += 0.05;
 if(anims[3] > 1.00) { anims[3] -= 1.00; }


 // UI selection pulsing animation
 //
 anims[4] += 4.0;
 if(anims[4] > 360.00) { anims[4] -= 360.00; }


 // Quake damage pulsing (fed into sin())
 //
 anims[5] += 8.0;
 if(anims[5] > 360.00) { anims[5] -= 360.00; }


 // Holding position shuffle (slow, lazy sine)
 //
 anims[6] += 0.01;
 if(anims[6] > 360.00) { anims[6] -= 360.00; }


 // Flashing Title indicator (50% to 100% opacity)
 //
 anims[7] += 0.04;
 if(anims[7] > 360.00) { anims[7] -= 360.00; }


 // Cape waving animation (fed into sin())
 //
 anims[8] += 8.0;
 if(anims[8] > 360.00) { anims[8] -= 360.00; }


 // Ball/Strike signal fade
 //
 anims[9] -= 0.01;
 if(anims[9] < 0.00) { anims[9] = 0.00; }


 // Title emoji rotation (360 degrees X 4)
 //
 anims[14] += 2.0;
 if(anims[14] >= 1440.00) { anims[14] -= 1440.00; }


 // Title emoji animation
 //
 anims[15] += 2.0;
 if(anims[15] >= 360.00) { anims[15] -= 360.00; }


 return;
}





// NOTE: Keeps track of game time, and parses the ticks left
//       into human readable format
//
void check_time()
{
 div_t d;
 div_t e;

 if(game_mode != 2) { return; }



 // Quake ticks
 //
 quake_ticks--;

 if(quake_ticks <= 0) {
     quake_ticks = quake_base + GetRandomValue(0, quake_spread);
                      }


 return;
}






// Kills off dead actors, spawns new ones over time
//
void check_actors()
{
 int i        = 0;
 int j        = 0;
 int k        = 0;
 int check    = 0;

 float volume = 1.0;
 float dist   = 0.0;
 float speed  = 0.1;

 Vector3 coords = { 0, 0 };


 // Check validity of pitch (if it hasn't been called a strike)
 // And deactivate dead pitches
 //
 // -1 = Dead ball, hit back wall without passing through strike zone
 // 0 = pitch in play
 // 1 = confirmed good; missed or otherwise not swung at
 // 2 = hit
 //
 if(pitch != -1 && game_mode == 2) {
     if(actors[pitch].good_pitch == 0) { actors[pitch].good_pitch = analyze_pitch(pitch); }

     if(abs(actors[pitch].path.x) < 0.1 &&
        abs(actors[pitch].path.y) < 0.1 &&
        abs(actors[pitch].path.z) < 0.1) {
            if(actors[pitch].good_pitch == -1) { umpire_signal(0); }
            if(actors[pitch].good_pitch == 1)  { umpire_signal(1); take_a_drink = 1; misses++; }
            pitch = -1;
            swung = 0;
                                         }
                                   }



 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {

         if(actors[i].shadow != -1) {
             k = actors[i].shadow;
             actors[k].pos.x = actors[i].pos.x;
             actors[k].pos.y = actors[i].pos.y - 1;
             actors[k].pos.z = actors[i].pos.z - 6;
                                    }

         if(actors[i].quake > 0.000) {
             actors[i].angle = sin(anims[5]) * actors[i].quake;
             actors[i].quake -= 0.15;
             if(actors[i].quake <= 0.000) {
                 actors[i].angle = 0.0;
                 actors[i].quake = 0.0;
                                          }
                                     }


         switch(actors[i].state) {
             case 0: // Inactive
                     break;

             case 1: // Object moving along vector
                     for(k=0; k<actors[i].updates; k++) {

                     // Create clone trail for baseball
                     //
                     if(/*actors[i].team == 2*/i == pitch) {
                         if(abs(actors[i].path.x) > 0.5 || abs(actors[i].path.y) > 0.5 || abs(actors[i].path.z) > 0.5) { spawn_trail(i); }
                                             }

                     // X vector check
                     //
                     check = check_move_collision(i, actors[i].path.x, 0.0, 0.0);
                     if(check) {
                         actors[i].path.x *= -0.70;
                         if(actors[i].team == 2 && check < 9) { toss_stuff(check-1, i, actors[i].path.x, 0.0, 0.0); }
                               }
                     else { actors[i].pos.x += actors[i].path.x; }


                     // Y vector check
                     //
                     check = check_move_collision(i, 0.0, actors[i].path.y, 0.0);
                     if(check) {
                         actors[i].path.y *= -0.70;
                         if(actors[i].team == 2 && check < 9) { toss_stuff(check-1, i, 0.0, actors[i].path.x, 0.0); }

                         // If the ball hits the back glass, spawn decal + sfx + score
                         //
                         if(actors[i].team == 2 && check == 12) {
                             if(actors[i].pos.x < 880 && actors[i].pos.z < 160) {
                                 spawn_decal(0, i);  quake_duration = 20;
                                                                                }
                                                                }
                               }
                     else { actors[i].pos.y += actors[i].path.y; }


                     // Z vector check
                     //
                     check = check_move_collision(i, 0.0, 0.0, actors[i].path.z);
                     if(check) {
                         actors[i].path.z *= -0.70;
                         if(actors[i].team == 2 && check < 9) { toss_stuff(check-1, i, 0.0, 0.0, actors[i].path.x); }
                               }
                     else { actors[i].pos.z += actors[i].path.z; }


                     actors[i].angle += actors[i].roll;

                     // Check for actors at floor level (bounce and simulate friction)
                     //
                     if(actors[i].pos.z < 0.00) {

                         // Special case: If ball hits the ground without passing through strike zone, mark it as "dead"
                         // No penalty against the player if it's not hit
                         // Hits will still be valid, however, and generate score
                         //
                         if(pitch == i && actors[i].good_pitch == 0) { actors[i].good_pitch = -1; }

                         actors[i].pos.z   =  0.00;
                         actors[i].path.x *=  0.60;
                         actors[i].path.y *=  0.60;
                         actors[i].path.z *= -0.50;
                                                }

                     if(actors[i].gravity) { actors[i].path.z -= GRAVITY_PULL; }

                     // Actors that are almost devoid of energy will cease rotating
                     //
                     // if(actors[i].path.z < 0.5 && actors[i].pos.z < 2.00) { actors[i].roll = 0.0; }
                     if(abs(actors[i].path.x) < 0.5 && abs(actors[i].path.y) < 0.5 && abs(actors[i].path.z) < 0.5) { actors[i].roll = 0.0; }
                                                   }
                     break;

             case 2: // Idle. Got tossed; now on floor
                     break;

             case 4: // Fading out, then expiring
                     actors[i].blend -= 0.03;
                     if(actors[i].blend <= 0.00 ) { kill_actor(i); }
                     break;

             case 5: // Pitcher (waits, winds up, throws, resets)
                     switch(actors[i].event) {
                         case 0: // Wait for next pitch
                                 actors[i].cel_x = 6;
                                 if(pitch == -1 && game_mode == 2) {
                                     actors[i].timer++;
                                     if(actors[i].timer > 100) { actors[i].event = 1; actors[i].timer = 0; }
                                                                   }
                                 break;

                         case 1: // Wind-up
                                 actors[i].cel_x = 7;
                                 actors[i].timer++;
                                 if(actors[i].timer > 80) { actors[i].event = 2; actors[i].timer = 0; }
                                 break;

                         case 2: // Throw and hold
                                 actors[i].cel_x = 8;

                                 if(actors[i].timer == 0) {
                                     pitch = pitch_baseball();
                                     balls_left--;
                                                          }
                                 actors[i].timer++;
                                 if(actors[i].timer > 120) { actors[i].event = 0; actors[i].timer = 0; }
                                 break;
                                             }
                     break;

             case 6: // Bottle. Hangs around, then tosses itself in the air
                     if(actors[i].timer == 0) { PlaySound(sfx[11]); }

                     actors[i].timer++;
                     if(actors[i].timer >= 180) {
                         actors[i].home    = -1;
                         actors[i].state   = 1;
                         actors[i].gravity = 1;
                         actors[i].roll    = -6.000 + (GetRandomValue(0, 12000) / 1000.0);
                         actors[i].path.x  = -2.000 + (GetRandomValue(0, 4000) / 1000.0);
                         actors[i].path.y  = -3.000 + (GetRandomValue(0, 6000) / 1000.0);
                         actors[i].path.z  = 3.0 + (GetRandomValue(0, 2000) / 1000.0);
                                                }
                     break;

             case 7: // Player is drinking. Wait a moment, then resume stuff
                     actors[i].timer++;
                     if(actors[i].timer >= 180) { actors[i].state = 0; }
                     break;

             case 8: // Fan blades. Just roll around
                     actors[i].angle += actors[i].roll;
                     break;

             case 9: // I've hacked this in quickly to get the sliding doors working
                     if(actors[i].stamina > 0) {
                         actors[i].pos.x += actors[i].path.x;
                         actors[i].stamina--;
                                               }
                     break;

            case 10: // Hacked in a pedestrian walking into the store
                     // This triggers two events
                     switch(actors[i].event) {
                         case 0: // Walking in
                                 actors[i].pos.y -= 1.00;
                                 actors[i].stamina--;

                                 // This is cute. I "waste" a frame, but get free animation cycling
                                 //
                                 actors[i].cel_x = 10 + ((actors[i].stamina / 15) % 4);

                                 if(actors[i].stamina == 145) { trigger_open_event(); }
                                 if(actors[i].stamina <= 0) { actors[i].event = 1; }
                                 break;

                         case 1: // Pausing in disbelief
                                 actors[i].cel_x = 11;
                                 actors[i].stamina--;
                                 if(actors[i].stamina < -300) { actors[i].stamina = 300; actors[i].event = 2; }
                                 break;

                         case 2: // Walking out
                                 actors[i].cel_x = 14;
                                 actors[i].pos.y += 1.00;
                                 actors[i].stamina--;

                                 actors[i].cel_x = 14 + ((actors[i].stamina / 15) % 4);

                                 if(actors[i].stamina == 100) { trigger_close_event(); }
                                 if(actors[i].stamina <= 0) {
                                     if(actors[i].shadow != -1) { kill_actor(actors[i].shadow); }
                                     kill_actor(i);
                                     customer = -1;
                                                            }
                                 break;
                                             }
                     break;
                                 }
                           }
                             }

 return;
}




// NOTE: Allow a customer to randomly spawn
//
void check_customers()
{
 int k = 0;

 if(customer == -1 && balls_left > 2) {
     k = GetRandomValue(0, 100000);

     if(k < 40) { customer = spawn_customer(); }
                                      }


 return;
}








void kill_actor(int slot)
{

 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { return; }

 int i = 0;

 actors[slot].enabled     = 0;
 actors[slot].projected   = 0;
 actors[slot].mirror      = 0;
 actors[slot].team        = 0;
 actors[slot].decal       = 0;
 actors[slot].shader      = 0;
 actors[slot].shadow      = -1;
 actors[slot].good_pitch  = 0;
 actors[slot].accessory   = 0;
 actors[slot].y_shift     = 0;
 actors[slot].gravity     = 0;
 actors[slot].flicker     = 0;
 actors[slot].anim_set    = 0;
 actors[slot].anim_step   = 0;
 actors[slot].anim_timing = 0;
 actors[slot].anim_loop   = 0;
 actors[slot].effect      = 0;
 actors[slot].state       = 0;
 actors[slot].mode        = 0;
 actors[slot].flip        = 0;
 actors[slot].timer       = 0;
 actors[slot]._size_w     = 16; // Default value
 actors[slot]._size_h     = 16; // Default value
 actors[slot].home        = -1;
 actors[slot].committed   = 0;
 actors[slot].event       = 0;
 actors[slot].locked_to   = -1;
 actors[slot].scale       = 1.0;
 actors[slot].v_angle     = 0.0;
 actors[slot].blend       = 1.0f;
 actors[slot].angle       = 0.0f;
 actors[slot].roll        = 0.0f;
 actors[slot].quake       = 0.0f;
 actors[slot].sinking     = 0.0f;
 actors[slot].speed       = 1.0f; // Default value
 actors[slot].stamina     = 1000;

 actors[slot].scale_ramp  = 0.0;
 actors[slot].scale_mod   = 1.0;
 actors[slot].scale_up    = 0.0;
 actors[slot].scale_down  = 0.0;

 actors[slot].updates     = 1;
 actors[slot].moved_up    = 0;
 actors[slot].moved_down  = 0;
 actors[slot].moved_wait  = 0;

 for(i=0; i<4; i++) { actors[slot].d_pad[i] = 0; actors[slot].buttons[i] = 0; }

 for(i=0; i<10; i++) { actors[slot].s_vars[i] = 0.0; }

 actors[slot].path.x      = 0;
 actors[slot].path.y      = 0;
 actors[slot].path.z      = 0;

 actors[slot].pos.x       = 0;
 actors[slot].pos.y       = 0;
 actors[slot].pos.z       = 0;

 actors[slot].dest.x      = 0;
 actors[slot].dest.y      = 0;
 actors[slot].dest.z      = 0;

 actors[slot].offset.x    = 0;
 actors[slot].offset.y    = 0;
 actors[slot].offset.z    = 0;

 actors[slot].cel         = tex_16x;
 actors[slot].color       = WHITE;
 return;
}






// Spawns a new actor. Types are 0-x for default skin
//
int spawn_actor(int type, float x, float y, float z, int cell_x, float path_x, float path_y, float path_z)
{
 int i    = 0;
 int slot = get_free_actor();

 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { return(-1); }

 actors[slot].mode      = 0;
 actors[slot].effect    = 0;
 actors[slot].projected = 1;
 actors[slot].blend     = 1.0f;
 actors[slot].angle     = 0.0f;
 actors[slot].timer     = 0;
 actors[slot].stamina   = GetRandomValue(500, 1200); // was 350, 500
 actors[slot].v_angle   = 0.0;
 actors[slot].locked_to = -1;

 actors[slot].pos.x     = x;
 actors[slot].pos.y     = y;
 actors[slot].pos.z     = z;

 actors[slot].path.x    = path_x;// * ((float)GetRandomValue(50, 200) / 100.0);
 actors[slot].path.y    = path_y;// * (float)GetRandomValue(1, 2);
 actors[slot].path.z    = path_z;// * (float)GetRandomValue(1, 2);

 actors[slot].cel       = tex_16x; // default value
 actors[slot].cel_x     = cell_x;
 actors[slot].cel_y     = 0;

 actors[slot].state     = 0;
 actors[slot].scale     = 1.0;

 actors[slot].enabled = 1;

 return(slot);
}







// Returns a slot to a free actor.
// If something goes wrong, we will clobber actor 0.
// Do something more graceful later
//
int get_free_actor()
{
 int i = 0;

 for(i=1; i<MAX_ACTORS; i++) {
     if(!actors[i].enabled) { return(i); }
                             }

 return(0);
}






void draw_actor(int slot)
{
 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { return; }

 if(!actors[slot].enabled) { return; }

 float x_flip    = 1.0;
 float s_flip    = 0.0;
 float dist      = 0.0;

 Vector2 coords  = { actors[slot].pos.x, actors[slot].pos.y };
 Vector2 coords2 = { 0, 0 };
 Vector2 origin  = { (actors[slot]._size_w / 2) * actors[slot].scale, (actors[slot]._size_h / 2) * actors[slot].scale };

 total_actors++;

 // Flip sprite horizontally if path of travel is negative on x axis
 //
 if(actors[slot].flip) { x_flip = -1.0; s_flip = - 4; }

 Rectangle source  = { (actors[slot]._size_w * actors[slot].cel_x), (actors[slot]._size_h * actors[slot].cel_y), actors[slot]._size_w * x_flip, actors[slot]._size_h };

 if(actors[slot].sinking) {
     source.height -= actors[slot].sinking;
                          }


 /// Setting the origin influences these values
 /// Note that we don't need to center the destination on the X axis
 ///                       vv vv vv vv
 Rectangle dest     = { actors[slot].pos.x, actors[slot].pos.y - ((actors[slot]._size_h * actors[slot].scale) / 2) - actors[slot].pos.z, (actors[slot]._size_w * actors[slot].scale), (actors[slot]._size_h * actors[slot].scale) };

 //dest.y -= actors[slot].pos.z;


 if(actors[slot].mirror) { source.width *= -1; }

 switch(actors[slot].effect) {
     case 2: // Custom drawing routine for rack
             //DrawLine(0, actors[slot].pos.y, 2000, actors[slot].pos.y, BLACK);
             //DrawLine(0, actors[slot].pos.y - 96, 2000, actors[slot].pos.y - 96, BLACK);
             //DrawLine(actors[slot].pos.x, 0, actors[slot].pos.x, 2000, BLACK);
             //DrawLine(actors[slot].pos.x + actors[slot].locked_to, 0, actors[slot].pos.x + actors[slot].locked_to, 2000, BLACK);
             DrawTextureEx(actors[slot].cel, (Vector2){actors[slot].pos.x,   (actors[slot].pos.y - (24.0 * 4))}, 0.0, 4.0, Fade(actors[slot].color, actors[slot].blend));
             break;

    default: // No effects
             // Shadow first, then sprite
             //if(actors[slot].shadow && actors[slot].pos.y < 0.2) {
             //    DrawTexturePro(tex_sprites, (Rectangle){32, 0, 16, 16}, dest, origin, actors[slot].angle, Fade(actors[slot].color, actors[slot].blend));
             //                                                    }
             //DrawLine(0, actors[slot].pos.y, 2000, actors[slot].pos.y, WHITE);
             //DrawLine(actors[slot].pos.x, 0, actors[slot].pos.x, 2000, WHITE);
             DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, actors[slot].blend));
             break;
                             }



 return;
}







int get_population(int team)
{
 int i = 0;
 int total = 0;

 for(i=1; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {
         if(actors[i].team == team) { total++; }
                           }
                             }

 return(total);
}






// NOTE: Draws the top/bottom banners for the title screen
//       Should only have minor changes between projects
//
void draw_title_hud()
{
 float   angle    = 0.0;
 float   alpha    = 0.0;
 Vector2 pos      = { 0, 0 };
 Vector2 len      = { 0, 0 };
 Vector2 origin   = { 128.0f, 128.0f };
 Rectangle source = { 0.0f, 0.0f, 128.0f, 128.0f };
 Rectangle dest   = { 0.0f, 0.0f, 256.0f, 256.0f };

 div_t d;


 // Draw four emoji, regularly spaced, and floating vertically via sine
 //
 dest.x = 200;
 dest.y = 400 + (sin(anims[15] * rad_conv) * 100);
 d = div((int)anims[14], 360);
 if(d.quot < 1) { angle = d.rem; }
 else           { angle = 0; }
 DrawTexturePro(tex_emoji_1, source, dest, origin, angle, WHITE);

 dest.x = 500;
 dest.y = 400 + (sin((anims[15] + 70) * rad_conv) * 100);
 d = div((int)anims[14], 360);
 if(d.quot == 1) { angle = d.rem; }
 else            { angle = 0; }
 DrawTexturePro(tex_emoji_2, source, dest, origin, angle, WHITE);

 dest.x = 800;
 dest.y = 400 + (sin((anims[15] + 140) * rad_conv) * 100);
 d = div((int)anims[14], 360);
 if(d.quot == 2) { angle = d.rem; }
 else            { angle = 0; }
 DrawTexturePro(tex_emoji_3, source, dest, origin, angle, WHITE);

 dest.x = 1100;
 dest.y = 400 + (sin((anims[15] + 210) * rad_conv) * 100);
 d = div((int)anims[14], 360);
 if(d.quot == 3) { angle = d.rem; }
 else            { angle = 0; }
 DrawTexturePro(tex_emoji_4, source, dest, origin, angle, WHITE);


 // Center title a little low vertically
 //
 pos.x = (SCREEN_W / 2) - (tex_title.width / 2);
 alpha = sin(anims[7]) * 0.5;
 DrawTexture(tex_title, pos.x, 350, Fade(WHITE, (0.75 + alpha)));



 len   = MeasureTextEx(font1, "PRESS [Z] TO START", font1.baseSize, 1);
 pos.x = (SCREEN_W / 2) - (len.x / 2);
 pos.y = SCREEN_H - 24;

 sprintf(custom_text, "PRESS [Z] TO START");
 DrawTextEx(font1, custom_text, pos, font1.baseSize, 1, Fade(WHITE, (1.0 * anims[3])));

 return;
}







void draw_hud()
{
 Vector2 len = { 0, 0 };
 Vector2 pos = { 0, 0 };


 len   = MeasureTextEx(font1, state_string[drunkosity], font1.baseSize * 2, 1);
 pos.x = 152 - (len.x / 2);
 pos.y = 28;

 DrawTextEx(font1, "- MODE -", (Vector2){ 84, 12 }, font1.baseSize, 1, YELLOW);
 DrawTextEx(font1, state_string[drunkosity], pos, font1.baseSize * 2, 1, WHITE);


 DrawTextEx(font1, "- PITCHES -", (Vector2){ 536, 12 }, font1.baseSize, 1, YELLOW);
 sprintf(custom_text, "%02d", balls_left);
 DrawTextEx(font1, custom_text, (Vector2){ 596, 28 }, font1.baseSize * 2, 1, WHITE);


 DrawTextEx(font1, "- SCORE -", (Vector2){ 1052, 12 }, font1.baseSize, 1, YELLOW);
 sprintf(custom_text, "%08d", score);
 DrawTextEx(font1, custom_text, (Vector2){  996, 28 }, font1.baseSize * 2, 1, WHITE);


 // Draw Control Hints
 //
 DrawTextEx(font3, "ARROW KEYS - ADJUST AIM       Z - HEAVY SWING       X - LIGHT SWING", (Vector2){80, SCREEN_H - 16}, font3.baseSize * 3, 1, Fade(BLACK, 0.75));
 DrawTextEx(font3, "ARROW KEYS                    Z                     X", (Vector2){80, SCREEN_H - 16}, font3.baseSize * 3, 1, Fade(ORANGE, 1.00));


 return;
}






void draw_signal(int signal)
{
 float dest_x = SCREEN_W / 2.0;
 float dest_y = SCREEN_H / 4.0;


 if(signal == 0) {
     dest_x -= tex_ball.width;
     DrawTextureEx(tex_ball,   (Vector2){dest_x, dest_y}, 0.0, 2.0, Fade(WHITE, anims[9]));
                 }

 if(signal == 1) {
     dest_x -= tex_strike.width;
     DrawTextureEx(tex_strike, (Vector2){dest_x, dest_y}, 0.0, 2.0, Fade(WHITE, anims[9]));
                 }


 // Dodgy, but we'll kill the signal off in here because I'm lazy
 //
 if(anims[9] <= 0.01) { show_signal = -1; }


 return;
}






// Copied-over framework stuff goes here



void FR_merge_actors()
{
 int i = 0;

 // Decals first
 //
 //BeginScissorMode(0, 168, 880, 152);
 for(i=0; i<MAX_ACTORS; i++) {
     if(sorted[i][1] != -1) {
         if(actors[sorted[i][1]].decal) { draw_actor(sorted[i][1]); }
                            }
                             }
 //EndScissorMode();

 // This should be in the rendering routine. But so lazy.
 //
 DrawTextureEx(tex_back_wall, (Vector2){0, 0}, 0.0, 4.0, WHITE);

 // Everything else
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(sorted[i][1] != -1) {
         if(!actors[sorted[i][1]].decal) { draw_actor(sorted[i][1]); }
                            }
                             }

 return;
}







// Add hook to allow for different manners of sorting outside the framework
//
// NOTE: For use with quicksort implementation
//
void FR_prep_for_sort()
{
 int i    = 0;

     for(i=0; i<MAX_ACTORS; i++) {
         sorted[i][0] = -1;
         sorted[i][1] = -1;

         if(actors[i].enabled && !actors[i].accessory) {
             sorted[i][0] = actors[i].pos.y;
             sorted[i][1] = i;
                                                       }
                                 }

 return;
}






// NOTE: OLD CODE IS OLD. Quicksort. Does what it says, says what it does.
//
void FR_quicksort(int low, int high)
{
 int top    = low;
 int bottom = (high - 1);
 int part_index;
 int part_value;

 if (low < high) {

     // Check if elements are sequential
     //
     if(high == (low + 1)) {
         if(sorted[low][0] > sorted[high][0]) { FR_swap_int(high, low, 0); }
                           }

     else {
         // Choose a partition element and swap it with
         // the last value in the array
         //
         part_index = (int)((low + high) / 2);
         part_value = sorted[part_index][0];
         FR_swap_int(high, part_index, 0);

         do {
	         // Inrement the top pointer
             //
	         while((sorted[top][0] <= part_value) && (top <= bottom)) { top++; }

	         // Decrement the bottom pointer
             //
	         while((sorted[bottom][0] > part_value) && (top <= bottom)) { bottom--; }

             // Swap elements if pointers have not met
             //
	         if(top < bottom) { FR_swap_int(top, bottom, 0); }
            } while(top < bottom);

     FR_swap_int(top, high, 0);

     // Recursive calls
     //
     FR_quicksort(low, top - 1);
     FR_quicksort(top + 1, high);
          }

                 }

 return;
}






// NOTE: OLD CODE IS OLD. For use with quicksort implementation
//
void FR_swap_int(int n1, int n2, int index)
{
 int temp;
 int temp2;

 temp  = sorted[n1][0];
 temp2 = sorted[n1][1];

 sorted[n1][0] = sorted[n2][0];
 sorted[n1][1] = sorted[n2][1];

 sorted[n2][0] = temp;
 sorted[n2][1] = temp2;

 return;
}







// OLD CODE IS OLD.
//
int FR_2d_dist(int x1, int y1, int x2, int y2)
{
 double d_x, d_y;
 double distance;

 d_x = x1 - x2;
 d_y = y1 - y2;

 d_x *= d_x;
 d_y *= d_y;

 distance = sqrt((d_x + d_y));

 return((int)distance);
}










void init_game_variables()
{
 int i = 0;
 int j = 0;

 hits         = 0;
 misses       = 0;
 cracks       = 0;
 launches     = 0;

 score        = 0;
 score_diff   = 0;
 score_shake  = 0;
 score_ticks  = 0;
 slow_time    = 0;
 slow_frame   = 0;
 yes_no       = 0;
 select       = 0;
 accept       = 0;
 p_light      = 0;
 p_heavy      = 0;
 p_l_hit      = 0;
 p_h_hit      = 0;
 puppet       = -1;
 pitch        = -1;
 show_signal  = -1;
 balls_left   = 20;
 take_a_drink = 0;
 drunkosity   = 0;
 swing_active = 0;
 swung        = 0;


 for(i=0; i<16; i++) { sfx_buffer[i][0] = -1; sfx_buffer[i][1] = 0; }
 for(i=0; i<16; i++) { anims[i] = 1.0; }
 for(i=0; i<4; i++)  { kill_off_step[i] = -1; }

 for(i=0; i<MAX_TEXTBOX; i++) {
     textbox[i].pos.x = 0.0;
     textbox[i].pos.y = 0.0;
     textbox[i].pos.width  = 0;
     textbox[i].pos.height = 0;
     textbox[i].scale = 0.0;
     textbox[i].mode = 0;
     textbox[i].ticks = 0;
     textbox[i].viewable_text = 0;
     textbox[i].msg = NULL;
     textbox[i].enabled = 0;
                              }



 // Define camera (this will center camera, with focus in middle of screen for rotation)
 // Suitable for use with zooming
 //
 camera.target   = (Vector2){ (float)SCREEN_W / 2.0f, (float)SCREEN_H / 2.0f };
 camera.offset   = (Vector2){ (float)SCREEN_W / 2.0f, (float)SCREEN_H / 2.0f };
 camera.rotation = 0.0f;
 camera.zoom     = 1.0f;


/*
 // Define camera (this will be a static camera locked to upper-left corner)
 // Not suitable for use with rotation. Zooming only.
 //
 camera.target   = (Vector2){ 0.0f, 0.0f };
 camera.offset   = (Vector2){ 0.0f, 0.0f };
 camera.rotation = 0.0f;
 camera.zoom     = 1.0f;
*/

 // Set up actors and spawns
 //
 for(i=0; i<MAX_ACTORS; i++) { kill_actor(i); }

 //generate_spawns();

 game_over     = 0;
 box_tex_x   = 0;
 box_tex_y   = 0;
 box_update  = 0;
 game_ticks    = SESSION_TIME;
 frame_ticks   = 0;
 game_mode     = 0;


 return;
}









// Ends game upon time-out.
// Player gets a review of their stats
// Player is then booted to the title screen (vars need to be reset)
//
void end_game()
{
 int exit = 0;
 int key  = 0;

 game_mode = 3;
 camera.rotation = 0.00;
 camera.zoom     = 1.00;


 do {
     update_and_render();
    } while(!IsKeyDown(KEY_Z));

 PlaySound(sfx[2]);

 do {
     update_and_render();
    } while(IsKeyDown(KEY_Z));


 return;
}






// Out of laziness, check each key and send back anything unique
// Valid keys are A-Z and 0-9. Returns 0 if no button seen
//
int get_initial()
{
 int check = 0;

 if(IsKeyPressed(KEY_A)) { return(65); }

 if(IsKeyPressed(KEY_B))  { return(66); }
 if(IsKeyPressed(KEY_C))  { return(67); }
 if(IsKeyPressed(KEY_D))  { return(68); }
 if(IsKeyPressed(KEY_E))  { return(69); }
 if(IsKeyPressed(KEY_F))  { return(70); }
 if(IsKeyPressed(KEY_G))  { return(71); }

 if(IsKeyPressed(KEY_H))  { return(72); }
 if(IsKeyPressed(KEY_I))  { return(73); }
 if(IsKeyPressed(KEY_J))  { return(74); }
 if(IsKeyPressed(KEY_K))  { return(75); }
 if(IsKeyPressed(KEY_L))  { return(76); }
 if(IsKeyPressed(KEY_M))  { return(77); }
 if(IsKeyPressed(KEY_N))  { return(78); }
 if(IsKeyPressed(KEY_O))  { return(79); }
 if(IsKeyPressed(KEY_P))  { return(80); }

 if(IsKeyPressed(KEY_Q))  { return(81); }
 if(IsKeyPressed(KEY_R))  { return(82); }
 if(IsKeyPressed(KEY_S))  { return(83); }
 if(IsKeyPressed(KEY_T))  { return(84); }
 if(IsKeyPressed(KEY_U))  { return(85); }
 if(IsKeyPressed(KEY_V))  { return(86); }
 if(IsKeyPressed(KEY_W))  { return(87); }
 if(IsKeyPressed(KEY_X))  { return(88); }
 if(IsKeyPressed(KEY_Y))  { return(89); }
 if(IsKeyPressed(KEY_Z))  { return(90); }

 if(IsKeyPressed(KEY_ZERO))  { return(48); }
 if(IsKeyPressed(KEY_ONE))   { return(49); }
 if(IsKeyPressed(KEY_TWO))   { return(50); }
 if(IsKeyPressed(KEY_THREE)) { return(51); }
 if(IsKeyPressed(KEY_FOUR))  { return(52); }
 if(IsKeyPressed(KEY_FIVE))  { return(53); }
 if(IsKeyPressed(KEY_SIX))   { return(54); }
 if(IsKeyPressed(KEY_SEVEN)) { return(55); }
 if(IsKeyPressed(KEY_EIGHT)) { return(56); }
 if(IsKeyPressed(KEY_NINE))  { return(57); }

 return(check);
}










// NOTE: Allegro-style CPU blitting operation
//
void blit(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 ImageDraw(&dest, src, s, d, WHITE);

 return;
}






// Vertically-flipped blit.
//
void blit_v(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 Image subs = ImageFromImage(src, s);
 ImageFlipVertical(&subs);

 s.x = 0;
 s.y = 0;
 ImageDraw(&dest, subs, s, d, WHITE);

 UnloadImage(subs);

 return;
}




// Horizontally-flipped blit.
//
void blit_h(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 Image subs = ImageFromImage(src, s);
 ImageFlipHorizontal(&subs);

 s.x = 0;
 s.y = 0;
 ImageDraw(&dest, subs, s, d, WHITE);

 UnloadImage(subs);

 return;
}




void assign_animation(int who, int anim, int loops)
{
 // Sanity Check
 //
 if(who < 0 || who >= MAX_ACTORS) { return; }

 actors[who].anim_set    = anim;
 actors[who].anim_step   = 0;
 actors[who].anim_timing = 0;
 actors[who].anim_loop   = loops;

 return;
}





void kill_animation(int who)
{
 // Sanity Check
 //
 if(who < 0 || who >= MAX_ACTORS) { return; }

 actors[who].anim_set    = 0;
 actors[who].anim_step   = 0;
 actors[who].anim_timing = 0;
 actors[who].anim_loop   = 0;

 return;
}





void trigger_textbox(int slot, int x, int y, int w, int h, int message, int delay, int duration)
{

 printf("TEXTBOX\n");
 // Sanity check slot and message

 textbox[slot].pos.x      = x;
 textbox[slot].pos.y      = y;
 textbox[slot].pos.width  = w;
 textbox[slot].pos.height = h;
 textbox[slot].scale      = 0.0;
 textbox[slot].duration   = duration;
 textbox[slot].mode       = 0 - delay;
 textbox[slot].ticks      = 0;
 textbox[slot].viewable_text = 0;
 textbox[slot].msg        = NULL; //hints[message];
 textbox[slot].enabled    = 1;

 return;
}





void show_stats()
{
 bool exit = 0;
 bool enter = 1;

 do {

    //actors[puppet].committed = 1000;

    if(enter)  { if(!IsKeyDown(KEY_X)) { enter = 0; } }
    if(!enter) { if(IsKeyDown(KEY_X))  { exit  = 1; } }

    update_and_render();

    } while(!exit);

 //actors[puppet].committed = 0;

 return;
}







// Draws game over score summary
//
void draw_summary()
{
 int txt_x     = 0;
 float pulse   = 0.0;
 float percent = 0.0;
 Vector2 len   = { 0, 0 };

 // Draw box texture as background
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 64, 32 };
 Rectangle tex_d = { 0, 0, SCREEN_W, SCREEN_H };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 // Game Over Screen Title (duh)
 //
 len   = MeasureTextEx(font1, "GAME  OVER", (font1.baseSize * 4), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);

 DrawTextEx(font1, "GAME  OVER", (Vector2){txt_x, 35}, font1.baseSize * 4, 1, WHITE);


 // Score and swing metrics
 //
 txt_x = 226;

 sprintf(custom_text, "TOTAL SCORE      %08d", score);
 DrawTextEx(font1, custom_text, (Vector2){txt_x, 200}, font1.baseSize * 2, 1, SCORE_GREEN);

 sprintf(custom_text, "HITS                %05d", hits);
 DrawTextEx(font1, custom_text, (Vector2){txt_x, 300}, font1.baseSize * 2, 1, YELLOW);

 sprintf(custom_text, "MISSES              %05d", misses);
 DrawTextEx(font1, custom_text, (Vector2){txt_x, 380}, font1.baseSize * 2, 1, YELLOW);

 sprintf(custom_text, "ITEMS LAUNCHED      %05d", launches);
 DrawTextEx(font1, custom_text, (Vector2){txt_x, 460}, font1.baseSize * 2, 1, YELLOW);

 sprintf(custom_text, "CRACKED GLASS       %05d", cracks);
 DrawTextEx(font1, custom_text, (Vector2){txt_x, 540}, font1.baseSize * 2, 1, YELLOW);

 sprintf(custom_text, "DRINKS              %05d", drunkosity);
 DrawTextEx(font1, custom_text, (Vector2){txt_x, 620}, font1.baseSize * 2, 1, YELLOW);


 // Press 'Z' to continue
 //
 len   = MeasureTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (font1.baseSize * 2), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);


 pulse = sin(anims[4] * rad_conv) * 0.50;
 DrawTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (Vector2){txt_x, SCREEN_H - 65}, font1.baseSize * 2, 1, Fade(WHITE, 0.50 + pulse));

 return;
}






// Draws ghetto-ass tutorial
//
void draw_tutorial()
{
 int txt_x   = 0;
 float pulse = 0.0;
 Vector2 len = { 0, 0 };

 // Draw box texture as background
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 64, 32 };
 Rectangle tex_d = { 0, 0, SCREEN_W, SCREEN_H };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 len   = MeasureTextEx(font1, "INSTRUCTIONS", (font1.baseSize * 4), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);

 DrawTextEx(font1, "INSTRUCTIONS", (Vector2){txt_x, 44}, font1.baseSize * 4, 1, WHITE);


 // NOTE: Next project, move this into a routine to clean this janky shit up
 //
 len   = MeasureTextEx(font1, "HIT PITCHES AND KNOCK AS MUCH STUFF DOWN AS POSSIBLE!", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "HIT PITCHES AND KNOCK AS MUCH STUFF DOWN AS POSSIBLE!", (Vector2){txt_x, 150}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "ADJUST YOUR BAT HEIGHT AND AIM WITH THE ARROW KEYS", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "ADJUST YOUR BAT HEIGHT AND AIM WITH THE ARROW KEYS", (Vector2){txt_x, 210}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "PRESS X FOR A POWERFUL SWING", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "PRESS X FOR A POWERFUL SWING", (Vector2){txt_x, 240}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "PRESS Z FOR A LIGHTER SWING", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "PRESS Z FOR A LIGHTER SWING", (Vector2){txt_x, 270}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "MISSING A GOOD PITCH MEANS YOU HAVE TO TAKE A DRINK", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "MISSING A GOOD PITCH MEANS YOU HAVE TO TAKE A DRINK", (Vector2){txt_x, 330}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "THE GAME ENDS WHEN YOU RUN OUT OF PITCHES", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "THE GAME ENDS WHEN YOU RUN OUT OF PITCHES", (Vector2){txt_x, 360}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "HITTING IS GOOD. DRINKING IS BAD.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "HITTING IS GOOD. DRINKING IS BAD.", (Vector2){txt_x, 470}, font1.baseSize * 1, 1, YELLOW);




 // Press 'Z' to continue
 //
 len   = MeasureTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (font1.baseSize * 2), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);

 pulse = sin(anims[4] * rad_conv) * 0.50;
 DrawTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (Vector2){txt_x, SCREEN_H - 65}, font1.baseSize * 2, 1, Fade(WHITE, 0.50 + pulse));

 return;
}









// Spawns baseball with random position and velocity
//
int spawn_baseball()
{
 int who = -1;

 who = spawn_actor(0, 500, 568, 0, 1, 0.0, 0.0, 0.0); // was 500

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 2;
     actors[who].scale   = 2.0;
     actors[who].state   = 1;
     //actors[who].pos.x   = GetRandomValue(60, 300);
     //actors[who].pos.y   = 568;
     actors[who].pos.z   = 40.0;
     actors[who].cel     = tex_16x;
       //actors[who].roll    = 2.0;
     actors[who].updates = 1;
     actors[who]._size_w = 16;
     actors[who]._size_h = 16;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].gravity = 1;
     actors[who].enabled = 1;
               }

 return(who);
}




// Spawns trail behind baseball that quickly fades out
//
int spawn_trail(int ball)
{
 int who = -1;

 who = spawn_actor(0, actors[ball].pos.x, actors[ball].pos.y - 0.50, actors[ball].pos.z, 2, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 4;
     actors[who].scale   = 2.0;
     actors[who].state   = 4;
     actors[who].cel     = tex_16x;
     actors[who]._size_w = 16;
     actors[who]._size_h = 16;
     actors[who].stamina = 100;
     actors[who].color   = WHITE;
     actors[who].gravity = 0;
     actors[who].enabled = 1;
               }

 return(who);
}




// Spawns crack on window (type 0 = back wall,  type 1 = front wall)
//
int spawn_decal(int type, int ball)
{
 int who = -1;

 who = spawn_actor(0, actors[ball].pos.x, actors[ball].pos.y, actors[ball].pos.z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = GetRandomValue(0,360);
     actors[who].decal   = 1;
     actors[who].team    = 4;
     actors[who].scale   = 4.0;
     actors[who].state   = 0;
     actors[who].cel     = tex_back_decal;
     actors[who]._size_w = 16;
     actors[who]._size_h = 16;
     actors[who].stamina = 100;
     actors[who].color   = WHITE;
     actors[who].gravity = 0;
     actors[who].enabled = 1;
               }

 score_diff += 5000; // Bonus for cracking the glass
 cracks++;


 PlaySound(sfx[9 + GetRandomValue(0,1)]);

 return(who);
}






// Spawns a rack. Coords map to bottom-left corner of actor (not center like normal)
// This is just for my convenience when laying out the screen.
//
int spawn_rack(int x, int y, int width, Texture2D texture)
{
 int who = -1;

 who = spawn_actor(0, 500, 500, 0, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle     = 0;
     actors[who].effect    = 2;
     actors[who].team      = 1;
     actors[who].scale     = 4.0;
     actors[who].state     = 0;
     actors[who].pos.x     = x * 4;
     actors[who].pos.y     = y * 4;
     actors[who].pos.z     = 0.0;
     actors[who].updates   = 1;
     actors[who].locked_to = width * 4;
     actors[who].cel       = texture;
     actors[who]._size_w   = texture.width;
     actors[who]._size_h   = texture.height;
     actors[who].stamina   = 1000;
     actors[who].color     = WHITE;
     actors[who].gravity   = 0;
     actors[who].enabled   = 1;
               }

 return(who);
}







// NOTE: Checks two floats and returns 1 if they are within range
//
int check_floats(float one, float two, float range)
{

 float check = fabs(one - two);

 if(check <= range) { return(1); }

 return(0);
}






// NOTE: Checks for collision with walls and racks before moving
//       Pass pre-movement coords in
//       returns 0 if all clear. Returns 1 if there's a collision
//
// NOTE: Suggest you check vectors individually, and if no contact has occurred,
//       commit the changes
//
// NOTE: Returns 1 for a wall reflection. Returns > 1 for a rack collision
//
int check_move_collision(int who, float x, float y, float z)
{
 int i         = 0;
 int k         = 0;
 float check_x = 0.0;
 float check_y = 0.0;
 float check_z = 0.0;

 float x1, x2, y1, y2;


 // Since we only have ONE projectile at a time, we can be *really* lazy
 // and check against all possible surfaces, each 1.0 pixel of travel.
 // (8 racks, 4 walls)
 // If a rack is struck, we go to another routine to determine which items get tossed
 //

 // Just walls for now
 // 0, 1276
 // 2000, 1400

 check_x = actors[who].pos.x + x;
 check_y = actors[who].pos.y + y;
 check_z = actors[who].pos.z + z;


 // Check walls and ceiling (floor is a separate case with different friction)
 //
 if(check_x >= 1276) { return(10); }
 if(check_x <=    4) { return(11); }

 if(check_y <=  320) { return(12); }
 if(check_y >=  956) { return(13); }

 if(check_z >=  260) { return(14); }


 // Check counters (3x)
 //
 if(check_x >= 881 && check_x <= 1120 &&
    check_y >= 320 && check_y <= 336 &&
    check_z <= 60) { printf("* COUNTER CONTACT #1 *\n"); return(20); }

 if(check_x >= 1124 && check_x <= 1172 &&
    check_y >= 320 && check_y <= 724 &&
    check_z <= 60) { printf("* COUNTER CONTACT #2 *\n"); return(21); }

 if(check_x >= 1173 && check_x <= 1275 &&
    check_y >= 716 && check_y <= 724 &&
    check_z <= 60) { printf("* COUNTER CONTACT #3 *\n"); return(22); }


 // Check racks (8x)
 //
 for(i=0; i<8; i++) {
     k = racks[i];
     x1 = actors[k].pos.x;
     x2 = actors[k].pos.x + actors[k].locked_to;
     y1 = actors[k].pos.y - 24;
     y2 = actors[k].pos.y;

     if(check_x >= x1 && check_x <= x2 &&
        check_y >= y1 && check_y <= y2 &&
        check_z <= 96) { /*printf("* COLLISION *   %f\n", anims[3]);*/ return(1 + i); }
                    }


 return(0);
}











void push_rect(Rectangle *rect, float x, float y, float w, float h)
{

 rect->x      = x;
 rect->y      = y;
 rect->width  = w;
 rect->height = h;

 return;
}





// NOTE: Has hard-coded coords and selections for rack contents. Positions
//       will be relative to the origin of the rack, so it can be repositioned
//       without consequence.
//
void populate_rack(int rack, int y_offset)
{
 int x = 0;
 int y = 0;
 int i = 0;

 if(rack < 0 || rack > 7) { printf("Rack OOB in populate rack. WTF mang? Rack = %d\n", rack); return; }

 x = actors[racks[rack]].pos.x;
 y = actors[racks[rack]].pos.y + y_offset;

 switch(rack) {

     case 0: // Top left rack
             for(i=0; i<10; i++) { spawn_bag(x + 16 + (32 * i), y, 40, 3, rack);  }
             for(i=0; i<4; i++)  { spawn_bag(x + 16 + (32 * i), y,  0, 11, rack); }
             for(i=0; i<12; i++) { spawn_bag(x + 136 + (16 * i), y, 0, 7, rack);  }
             break;

     case 1: // Top right rack
             for(i=0; i<8; i++) { spawn_bag(x + 16 + (32 * i), y, 40, 3, rack);  }
             for(i=0; i<6; i++) { spawn_bag(x + 16 + (32 * i), y,  0, 11, rack); }
             for(i=0; i<5; i++) { spawn_bag(x + 196 + (16 * i), y, 0, 7, rack);  }
             break;

     case 2:
             for(i=0; i<21; i++) { spawn_bag(x + 16 + (32 * i), y, 40, 3, rack);   }
             for(i=0; i<4; i++)  { spawn_bag(x + 16 + (32 * i), y,  0, 11, rack);  }
             for(i=0; i<8; i++)  { spawn_bag(x + 136 + (16 * i), y, 0, 7, rack);   }
             for(i=0; i<6; i++)  { spawn_bag(x + 272 + (32 * i), y,  0, 15, rack); }
             for(i=0; i<10; i++) { spawn_bag(x + 456 + (16 * i), y, 0, 7, rack);   }
             for(i=0; i<3; i++)  { spawn_bag(x + 624 + (28 * i), y, 0, 11, rack);  }
             break;

     case 3: // Left middle rack
             for(i=0; i<8; i++) { spawn_bag(x + 16 + (32 * i), y, 40, 3, rack);  }
             for(i=0; i<4; i++) { spawn_bag(x + 16 + (32 * i), y,  0, 11, rack); }
             for(i=0; i<8; i++) { spawn_bag(x + 136 + (16 * i), y, 0, 7, rack);  }
             break;

     case 4: //
             for(i=0; i<10; i++) { spawn_bag(x + 16 + (32 * i), y, 40, 3, rack);   }
             for(i=0; i<4; i++)  { spawn_bag(x + 16 + (32 * i), y,  0, 11, rack);  }
             for(i=0; i<7; i++)  { spawn_bag(x + 136 + (16 * i), y, 0, 7, rack);   }
             for(i=0; i<3; i++)  { spawn_bag(x + 260 + (32 * i), y,  0, 15, rack); }
             break;

     case 5:
             for(i=0; i<11; i++) { spawn_bag(x + 16 + (32 * i), y, 40, 3, rack);   }
             for(i=0; i<4; i++)  { spawn_bag(x + 16 + (32 * i), y,  0, 15, rack);  }
             for(i=0; i<8; i++)  { spawn_bag(x + 136 + (16 * i), y, 0, 7, rack);   }
             for(i=0; i<3; i++)  { spawn_bag(x + 272 + (32 * i), y,  0, 15, rack); }
             break;

     case 6:
             for(i=0; i<7; i++) { spawn_bag(x + 16 + (32 * i), y, 40, 3, rack);  }
             for(i=0; i<4; i++) { spawn_bag(x + 16 + (32 * i), y,  0, 11, rack); }
             for(i=0; i<7; i++) { spawn_bag(x + 136 + (16 * i), y, 0, 7, rack);  }
             break;

     case 7:
             for(i=0; i<21; i++) { spawn_bag(x + 16 + (32 * i), y, 40, 3, rack);   }
             for(i=0; i<4; i++)  { spawn_bag(x + 16 + (32 * i), y,  0, 11, rack);  }
             for(i=0; i<8; i++)  { spawn_bag(x + 136 + (16 * i), y, 0, 7, rack);   }
             for(i=0; i<6; i++)  { spawn_bag(x + 272 + (32 * i), y,  0, 15, rack); }
             for(i=0; i<10; i++) { spawn_bag(x + 456 + (16 * i), y, 0, 7, rack);   }
             for(i=0; i<3; i++)  { spawn_bag(x + 624 + (28 * i), y, 0, 11, rack);  }
             break;
              }

 return;
}




int spawn_bag(int x, int y, int z, int frame_x, int rack)
{
 int who = -1;

 if(rack < 0 || rack > 7) { printf("Rack OOB in spawn bag. WTF mang? Rack = %d\n", rack); return(-1); }

 who = spawn_actor(0, 0, 0, 0, frame_x + GetRandomValue(0, 3), 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 3;
     actors[who].home    = rack;
     actors[who].scale   = 4.0;
     actors[who].state   = 0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y + 1;
     actors[who].pos.z   = z;
     actors[who].updates = 2;
     actors[who].cel     = tex_16x;
     actors[who]._size_w = 16;
     actors[who]._size_h = 16;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}





// NOTE: Checks nearby objects and tosses anything that's close to the point of collision
//
void toss_stuff(int rack, int who, int col_x, int col_y, int col_z)
{
 bool  strike  = 0;
 int   i       = 0;
 int   k       = 0;
 float dist    = 0.0;
 float check_x = 0.0;
 float check_y = 0.0;
 float check_z = 0.0;

 // Sanity checks
 //
 if(who < 0 || who >= MAX_ACTORS) { printf("Who OOB in toss stuff. WTF mang? Who = %d\n", who); return; }
 if(rack < 0 || rack > 7) { printf("Rack OOB in toss stuff. WTF mang? Rack = %d\n", rack); return; }

 check_x = actors[who].pos.x + col_x;
 check_y = actors[who].pos.y + col_y;
 check_z = actors[who].pos.z + col_z;

 quake_duration = 10;

 // Launch anything on that rack that's in range.
 // We should come up with a quick formula to scale the range with velocity.
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].home == rack) {
         dist = FR_2d_dist(actors[who].pos.x, actors[who].pos.y, actors[i].pos.x, actors[i].pos.y);
         if(dist < 64) {
             strike = 1;

             actors[i].home    = -1;
             actors[i].state   = 1;
             actors[i].gravity = 1;
             actors[i].roll    = -6.000 + (GetRandomValue(0, 12000) / 1000.0);
             actors[i].path.x  = -3.000 + (GetRandomValue(0, 6000) / 1000.0);
             actors[i].path.y  = -3.000 + (GetRandomValue(0, 6000) / 1000.0);
             actors[i].path.z  = 5.0 + (GetRandomValue(0, 3000) / 1000.0);

             score_diff += 250;
             launches++;
                       }
                                }
                             }

 if(strike) { // We hit something!
     //PlaySound(sfx[8]);
     //SetSoundPitch(sfx[8], (0.50 + (GetRandomValue(0, 1000) / 1000.0)));

     i = GetRandomValue(1, 3);
     for(k=0; k<i; k++) {
         buffer_sfx(20 + GetRandomValue(0, 3), (20 * k));
                        }
            }

 return;
}





int pitch_baseball()
{
 float toss_scale = 0.0;
 int who = spawn_baseball();

 if(who != -1) {

/*
            actors[k].path.x = 20.000;
            actors[k].path.y = -3.000 + (GetRandomValue(0, 6000) / 1000.0);
            actors[k].path.z = 5.0 + (GetRandomValue(0, 3000) / 1000.0);
*/
     // X vector should also map to Z vector (Higher Z values decrease X)
     // Ball should arrive in roughly the same spot each time.
     // We will use a highly unscientific fudge factor to arrive at a reasonable X component.
     // The reason results aren't consistent is that gravity is a constant value per tick.
     // Ideally you'd compensate for that with a non-linear response curve.
     // Laziness actually works out well enough this time.
     //
     actors[who].pos.x = 1040;

     toss_scale = (GetRandomValue(0, 2000) / 1000.0);  // Variation in pitch arc (higher = more height)
     actors[who].path.x = -18.000 + (toss_scale * 5.25); // Science, bitches
     actors[who].path.y = 0.0;
     actors[who].path.z = 2.5 + toss_scale;
               }

 return(who);
}





// NOTE: Checks ball against the "strike zone", which happens to be
//       an exact match for the area the bat will reach. No walking for you!
//
// NOTE: Returns 1 if ball is in the strike zone. Else 0.
//
int analyze_pitch(int ball)
{
 bool x_good = 0;
 bool z_good = 0;

 // sanitize vars
 //
 if(ball < 0 || ball >= MAX_ACTORS) { return(0); }


 if(actors[ball].pos.x >= 100 && actors[ball].pos.x <= 180) { x_good = 1; }
 if(actors[ball].pos.z >= 5 && actors[ball].pos.z <= 80)    { z_good = 1; }


 if(x_good && z_good) { return(1); }
 else                 { return(0); }
}





// NOTE: Checks ball against the bat position
//
// NOTE: Returns 1 on a good swing. Else 0.
//
int analyze_swing(bool power, int up, int down, int ball)
{
 float MAX_PULL  = 10.00;
 float MAX_LOFT  = 5.00;
 float BAT_SHIFT = 0.00;

 if(up)   { BAT_SHIFT =  15; }
 if(down) { BAT_SHIFT = -15; }

 // sanitize vars
 //
 if(ball < 0 || ball >= MAX_ACTORS) { return(0); }


 if(actors[ball].pos.x < 100 || actors[ball].pos.x > 180) { return(0); } // WHIFF!
 if(actors[ball].pos.z <  (20 + BAT_SHIFT) || actors[ball].pos.z > (65 + BAT_SHIFT)) { return(0); } // WHIFF!


 // set Y component based off of ball position relative to bat (120-180 = MAX_PULL to -MAX_PULL
 //
 actors[ball].path.y = -scale(actors[ball].pos.x, 100, 180, -MAX_PULL, MAX_PULL);
 actors[ball].path.z = 5.50 + scale(actors[ball].pos.z, (20 + BAT_SHIFT), (65 + BAT_SHIFT), -MAX_LOFT, MAX_LOFT);


 if(power) { actors[ball].path.x *= -1.75; }
 else      { actors[ball].path.x *= -1.10; }

 debug[0] = actors[ball].pos.x;
 debug[1] = actors[ball].pos.y;
 debug[2] = actors[ball].pos.z;

 debug[3] = actors[puppet].pos.x + 44;
 debug[4] = actors[puppet].pos.y;
 debug[5] = 40;
 if(up)   { debug[5] = 56; }
 if(down) { debug[5] = 24; }


 // We have to mark the pitched ball as being hit, so we don't count it against
 // the player when it stops moving
 //
 if(pitch != -1) { actors[pitch].good_pitch = 2; }

 PlaySound(sfx[4 + GetRandomValue(0,3)]);
 hits++;

 return(1); // HIT
}





// NOTE: Basic scaling routine
//       Translates source to scaled
//
float scale(float value, float source_min, float source_max, float scaled_min, float scaled_max)
{
 long double percentage = 0;

 if((source_max - source_min) == 0.000) { return(0); } // If used in framework, signal division by zero

 percentage = (value - source_min) / (source_max - source_min);

 return ((percentage * (scaled_max - scaled_min)) + scaled_min);
}





// NOTE: Displays a "STRIKE!" or "BALL" signal for the player.
//       type 0 = BALL
//       type 1 = STRIKE
//
void umpire_signal(int type)
{
 int who     = -1;


 // Set the UI flag and timer accordingly
 // Setting the timer to 2.00 allows for an extra 100 ticks before the signal fades out
 // Raylib doesn't care if you set alpha over 1.00 for fade, it'll clip :D
 //
 show_signal = type;
 anims[9]    = 2.00;


 // If a ball is issued, give the player a refund. I'm not *that* much of a dick, yo.
 //
 if(!type) { balls_left++; }


 // If a strike is issued, give the player enough time to drink,
 // And spawn the drink, etc etc
 //
 if(type == 1) {
     if(pitcher != -1) { actors[pitcher].timer = -300; }

     who = spawn_actor(0, actors[puppet].pos.x + 20, actors[puppet].pos.y + 1, 42.0, 19, 0.0, 0.0, 0.0);

     if(who != -1) {
         actors[who].angle   = 225;
         actors[who].team    = 3;
         actors[who].scale   = 4.0;
         actors[who].state   = 6; // Bottle state
         actors[who].cel     = tex_16x;
         actors[who]._size_w = 16;
         actors[who]._size_h = 16;
         actors[who].color   = WHITE;
         actors[who].enabled = 1;
                   }

     // Player needs signal to drink
     //
     if(puppet != -1) {
         actors[puppet].state = 7;
         actors[puppet].timer = 0;
                      }
               }


 return;
}




void buffer_sfx(int sfx_slot, int ticks)
{
 int i = 0;

 for(i=0; i<16; i++) {
     if(sfx_buffer[i][0] == -1) {
         sfx_buffer[i][0] = sfx_slot;
         sfx_buffer[i][1] = ticks;
         return;
                                }

                     }

 printf("Couldn't queue sfx. No slots available\n");

 return;
}





int spawn_customer()
{
 int who = -1;
 int k   = -1;
 int j   = 0;

 who = spawn_actor(0, 258 * 4, 300 * 4, 0.0,  11,  0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].scale   = 4.0;
     actors[who].stamina = 300;
     actors[who].state   = 10; // Pedestrian
     actors[who].event   = 0;  // Walking in
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].enabled = 1;

     // Color is randomizer (because of course it is)
     //
     j = GetRandomValue(0, 3);
     if(j == 0) { actors[who].color = CUSTOMER_GREEN;  }
     if(j == 1) { actors[who].color = CUSTOMER_CYAN;   }
     if(j == 2) { actors[who].color = CUSTOMER_PURPLE; }
     if(j == 3) { actors[who].color = CUSTOMER_YELLOW; }


     // ...and shadow
     //
     k = spawn_actor(0, 0, 0, 0, 19, 0.0, 0.0, 0.0);
     actors[k].scale   = 4.0;
     actors[k].cel     = tex_32x;
     actors[k]._size_w = 32;
     actors[k]._size_h = 32;

     actors[who].shadow = k;
               }


 return(who);
}





void trigger_open_event()
{

 // Doors open
 //
 actors[doors[0]].stamina = 122;
 actors[doors[0]].path.x  = -0.50;

 actors[doors[1]].stamina = 122;
 actors[doors[1]].path.x  = 0.50;

 // Queue door open/close and "ding!" sound effects
 //
 buffer_sfx(25, 0);
 buffer_sfx(24, 120);


 return;
}






void trigger_close_event()
{

 // Doors Close
 //
 actors[doors[0]].stamina = 122;
 actors[doors[0]].path.x  = 0.50;

 actors[doors[1]].stamina = 122;
 actors[doors[1]].path.x  = -0.50;

 // Queue door open/close sound effect (NO DING!)
 //
 buffer_sfx(25, 0);
 //buffer_sfx(24, 120);


 return;
}
